/*
 * このソースコードは blanco Frameworkによって自動生成されています。
 * Apache Antタスク [BlancoNLpackGeneratorOmitXliff]のクラス
 */
package blanco.nlpack.generator.task;

import org.apache.tools.ant.BuildException;
import org.apache.tools.ant.Task;

import blanco.nlpack.generator.task.valueobject.BlancoNLpackGeneratorOmitXliffProcessInput;

/**
 * Apache Antタスク [BlancoNLpackGeneratorOmitXliff]のクラス。
 *
 * [XLIFF対応ツール] 除外ルールに従って XLIFFファイル(*.xlf) から項目を除外します。<br>
 * このクラスでは、Apache Antタスクで一般的に必要なチェックなどのコーディングを肩代わりします。
 * 実際の処理は パッケージ[blanco.nlpack.generator.task]にBlancoNLpackGeneratorOmitXliffBatchProcessクラスを作成して記述してください。<br>
 * <br>
 * Antタスクへの組み込み例<br>
 * <pre>
 * &lt;taskdef name=&quot;blanconlpackgeneratoromitxliff&quot; classname=&quot;blanco.nlpack.generator.task.BlancoNLpackGeneratorOmitXliffTask">
 *     &lt;classpath&gt;
 *         &lt;fileset dir=&quot;lib&quot; includes=&quot;*.jar&quot; /&gt;
 *         &lt;fileset dir=&quot;lib.ant&quot; includes=&quot;*.jar&quot; /&gt;
 *     &lt;/classpath&gt;
 * &lt;/taskdef&gt;
 * </pre>
 */
public class BlancoNLpackGeneratorOmitXliffTask extends Task {
    /**
     * [XLIFF対応ツール] 除外ルールに従って XLIFFファイル(*.xlf) から項目を除外します。
     */
    protected BlancoNLpackGeneratorOmitXliffProcessInput fInput = new BlancoNLpackGeneratorOmitXliffProcessInput();

    /**
     * [XLIFF対応ツール] 除外ルールに従って XLIFFファイル(*.xlf) から項目を除外します。
     */
    protected boolean fIsFieldXliffdirProcessed = false;

    /**
     * [XLIFF対応ツール] 除外ルールに従って XLIFFファイル(*.xlf) から項目を除外します。
     */
    protected boolean fIsFieldTmpdirProcessed = false;

    /**
     * [XLIFF対応ツール] 除外ルールに従って XLIFFファイル(*.xlf) から項目を除外します。
     */
    protected boolean fIsFieldIsforceiftargetexistProcessed = false;

    /**
     * verboseモードで動作させるかどうか。
     *
     * @param arg verboseモードで動作させるかどうか。
     */
    public void setVerbose(final boolean arg) {
        fInput.setVerbose(arg);
    }

    /**
     * verboseモードで動作させるかどうか。
     *
     * @return verboseモードで動作させるかどうか。
     */
    public boolean getVerbose() {
        return fInput.getVerbose();
    }

    /**
     * Antタスクの[xliffdir]アトリビュートのセッターメソッド。
     *
     * 項目番号: 1<br>
     * XLIFFファイルが格納されている入力／出力先ルート・フォルダを指定します。XLIFFファイルは Bundle-SymbolicName ディレクトリ内に格納されることを前提とします。<br>
     *
     * @param arg セットしたい値
     */
    public void setXliffdir(final String arg) {
        fInput.setXliffdir(arg);
        fIsFieldXliffdirProcessed = true;
    }

    /**
     * Antタスクの[xliffdir]アトリビュートのゲッターメソッド。
     *
     * 項目番号: 1<br>
     * XLIFFファイルが格納されている入力／出力先ルート・フォルダを指定します。XLIFFファイルは Bundle-SymbolicName ディレクトリ内に格納されることを前提とします。<br>
     * 必須アトリビュートです。Apache Antタスク上で必ず値が指定されます。<br>
     *
     * @return このフィールドの値
     */
    public String getXliffdir() {
        return fInput.getXliffdir();
    }

    /**
     * Antタスクの[tmpdir]アトリビュートのセッターメソッド。
     *
     * 項目番号: 2<br>
     * テンポラリディレクトリを指定します。無指定の場合にはカレント直下のtmpを用います。<br>
     *
     * @param arg セットしたい値
     */
    public void setTmpdir(final String arg) {
        fInput.setTmpdir(arg);
        fIsFieldTmpdirProcessed = true;
    }

    /**
     * Antタスクの[tmpdir]アトリビュートのゲッターメソッド。
     *
     * 項目番号: 2<br>
     * テンポラリディレクトリを指定します。無指定の場合にはカレント直下のtmpを用います。<br>
     * デフォルト値[tmp]が設定されています。Apache Antタスク上でアトリビュートの指定が無い場合には、デフォルト値が設定されます。<br>
     *
     * @return このフィールドの値
     */
    public String getTmpdir() {
        return fInput.getTmpdir();
    }

    /**
     * Antタスクの[isforceiftargetexist]アトリビュートのセッターメソッド。
     *
     * 項目番号: 3<br>
     * ターゲットが既にある場合に除外処理を強行するかどうか。<br>
     *
     * @param arg セットしたい値
     */
    public void setIsforceiftargetexist(final boolean arg) {
        fInput.setIsforceiftargetexist(arg);
        fIsFieldIsforceiftargetexistProcessed = true;
    }

    /**
     * Antタスクの[isforceiftargetexist]アトリビュートのゲッターメソッド。
     *
     * 項目番号: 3<br>
     * ターゲットが既にある場合に除外処理を強行するかどうか。<br>
     * デフォルト値[false]が設定されています。Apache Antタスク上でアトリビュートの指定が無い場合には、デフォルト値が設定されます。<br>
     *
     * @return このフィールドの値
     */
    public boolean getIsforceiftargetexist() {
        return fInput.getIsforceiftargetexist();
    }

    /**
     * Antタスクのメイン処理。Apache Antから このメソッドが呼び出されます。
     *
     * @throws BuildException タスクとしての例外が発生した場合。
     */
    public final void execute() throws BuildException {
        System.out.println("BlancoNLpackGeneratorOmitXliffTask begin.");

        // 項目番号[1]、アトリビュート[xliffdir]は必須入力です。入力チェックを行います。
        if (fIsFieldXliffdirProcessed == false) {
            throw new BuildException("必須アトリビュート[xliffdir]が設定されていません。処理を中断します。");
        }

        if (getVerbose()) {
            System.out.println("- verbose:[true]");
            System.out.println("- xliffdir:[" + getXliffdir() + "]");
            System.out.println("- tmpdir:[" + getTmpdir() + "]");
            System.out.println("- isforceiftargetexist:[" + getIsforceiftargetexist() + "]");
        }

        try {
            // 実際のAntタスクの主処理を実行します。
            // この箇所でコンパイルエラーが発生する場合、BlancoNLpackGeneratorOmitXliffProcessインタフェースを実装して blanco.nlpack.generator.taskパッケージに BlancoNLpackGeneratorOmitXliffProcessImplクラスを作成することにより解決できる場合があります。
            final BlancoNLpackGeneratorOmitXliffProcess proc = new BlancoNLpackGeneratorOmitXliffProcessImpl();
            if (proc.execute(fInput) != BlancoNLpackGeneratorOmitXliffBatchProcess.END_SUCCESS) {
                throw new BuildException("タスクは異常終了しました。");
            }
        } catch (IllegalArgumentException e) {
            if (getVerbose()) {
                e.printStackTrace();
            }
            throw new BuildException(e.getMessage());
        } catch (Exception e) {
            e.printStackTrace();
            throw new BuildException("タスクを処理中に例外が発生しました。処理を中断します。" + e.toString());
        } catch (Error e) {
            e.printStackTrace();
            throw new BuildException("タスクを処理中にエラーが発生しました。処理を中断します。" + e.toString());
        }
    }
}
